Package org.opencv.xfeatures2d

## Class BEBLID

- java.lang.Object
- - org.opencv.core.Algorithm
  - - org.opencv.features.Feature2D
    - - org.opencv.xfeatures2d.BEBLID

-     public class BEBLID
      extends Feature2D

  Class implementing BEBLID (Boosted Efficient Binary Local Image Descriptor), described in CITE: Suarez2020BEBLID . BEBLID \cite Suarez2020BEBLID is a efficient binary descriptor learned with boosting. It is able to describe keypoints from any detector just by changing the scale_factor parameter. In several benchmarks it has proved to largely improve other binary descriptors like ORB or BRISK with the same efficiency. BEBLID describes using the difference of mean gray values in different regions of the image around the KeyPoint, the descriptor is specifically optimized for image matching and patch retrieval addressing the asymmetries of these problems. If you find this code useful, please add a reference to the following paper: <BLOCKQUOTE> Iago Suárez, Ghesn Sfeir, José M. Buenaposada, and Luis Baumela. BEBLID: Boosted efficient binary local image descriptor. Pattern Recognition Letters, 133:366–372, 2020. </BLOCKQUOTE> The descriptor was trained using 1 million of randomly sampled pairs of patches (20% positives and 80% negatives) from the Liberty split of the UBC datasets \cite winder2007learning as described in the paper CITE: Suarez2020BEBLID. You can check in the [AKAZE example](https://raw.githubusercontent.com/opencv/opencv/master/samples/cpp/tutorial_code/features2D/AKAZE_match.cpp) how well BEBLID works. Detecting 10000 keypoints with ORB and describing with BEBLID obtains 561 inliers (75%) whereas describing with ORB obtains only 493 inliers (63%).

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `SIZE_256_BITS` |
    `static int` | `SIZE_512_BITS` |

    - ### Fields inherited from class org.opencv.core.Algorithm

      `nativeObj`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `BEBLID​(long addr)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static BEBLID` | `__fromPtr__​(long addr)` |
    `static BEBLID` | `create​(float scale_factor)` | Creates the BEBLID descriptor.
    `static BEBLID` | `create​(float scale_factor, int n_bits)` | Creates the BEBLID descriptor.
    `protected void` | `finalize()` |
    `java.lang.String` | `getDefaultName()` | Returns the algorithm string identifier.
    `float` | `getScaleFactor()` |
    `void` | `setScaleFactor​(float scale_factor)` |

    - ### Methods inherited from class org.opencv.features.Feature2D

      `compute, compute, defaultNorm, descriptorSize, descriptorType, detect, detect, detect, detect, detectAndCompute, detectAndCompute, empty, read, write`

    - ### Methods inherited from class org.opencv.core.Algorithm

      `clear, getNativeObjAddr, save`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### SIZE_512_BITS

          public static final int SIZE_512_BITS

      See Also:
        Constant Field Values

    - #### SIZE_256_BITS

          public static final int SIZE_256_BITS

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### BEBLID

          protected BEBLID​(long addr)

  - ### Method Detail

    - #### __fromPtr__

          public static BEBLID __fromPtr__​(long addr)

    - #### create

          public static BEBLID create​(float scale_factor,
                                      int n_bits)

      Creates the BEBLID descriptor.
      Parameters:
        `scale_factor` - Adjust the sampling window around detected keypoints:
        - <b> 1.00f </b> should be the scale for ORB keypoints
        - <b> 6.75f </b> should be the scale for SIFT detected keypoints
        - <b> 6.25f </b> is default and fits for KAZE, SURF detected keypoints
        - <b> 5.00f </b> should be the scale for AKAZE, MSD, AGAST, FAST, BRISK keypoints
        `n_bits` - Determine the number of bits in the descriptor. Should be either BEBLID::SIZE_512_BITS or BEBLID::SIZE_256_BITS.
      Returns:
        automatically generated

    - #### create

          public static BEBLID create​(float scale_factor)

      Creates the BEBLID descriptor.
      Parameters:
        `scale_factor` - Adjust the sampling window around detected keypoints:
        - <b> 1.00f </b> should be the scale for ORB keypoints
        - <b> 6.75f </b> should be the scale for SIFT detected keypoints
        - <b> 6.25f </b> is default and fits for KAZE, SURF detected keypoints
        - <b> 5.00f </b> should be the scale for AKAZE, MSD, AGAST, FAST, BRISK keypoints
        BEBLID::SIZE_512_BITS or BEBLID::SIZE_256_BITS.
      Returns:
        automatically generated

    - #### setScaleFactor

          public void setScaleFactor​(float scale_factor)

    - #### getScaleFactor

          public float getScaleFactor()

    - #### getDefaultName

          public java.lang.String getDefaultName()

      Description copied from class: `Algorithm`
      Returns the algorithm string identifier. This string is used as top level xml/yml node tag when the object is saved to a file or string.
      Overrides:
        `getDefaultName` in class `Feature2D`
      Returns:
        automatically generated

    - #### finalize

          protected void finalize()
                           throws java.lang.Throwable

      Overrides:
        `finalize` in class `Feature2D`
      Throws:
        `java.lang.Throwable`